commit:     d7be0fd173d14a579fe1fd11da1b6ec889716da2
Author:     Ionen Wolkens <ionen <AT> gentoo <DOT> org>
AuthorDate: Fri Apr 28 21:35:16 2023 +0000
Commit:     Ionen Wolkens <ionen <AT> gentoo <DOT> org>
CommitDate: Fri Apr 28 21:35:23 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=d7be0fd1

app-emulation/wine-vanilla: add 8.7

Signed-off-by: Ionen Wolkens <ionen <AT> gentoo.org>

 app-emulation/wine-vanilla/Manifest                |   1 +
 app-emulation/wine-vanilla/wine-vanilla-8.7.ebuild | 335 +++++++++++++++++++++
 2 files changed, 336 insertions(+)

diff --git a/app-emulation/wine-vanilla/Manifest 
b/app-emulation/wine-vanilla/Manifest
index 7459190c35c0..0701218424d3 100644
--- a/app-emulation/wine-vanilla/Manifest
+++ b/app-emulation/wine-vanilla/Manifest
@@ -4,3 +4,4 @@ DIST wine-8.0.1.tar.xz 29057128 BLAKE2B 
f1e04ddc7531704b4229d1bdb6e742ff20886dff
 DIST wine-8.0.tar.xz 29054044 BLAKE2B 
baf8f96b665119c9f38a148a2472dbe8f6ca8d4641d9d09d48cb72cb4de2585c274b8b7981c2fa622ead6da2f087c57652e9b48edc8a17c0cfd6be9a36732f02
 SHA512 
53ba813b260a65a271ec575822725b97631f60038fb026dcc0fe66862711eedcc29a8feb29ff54ae4f64458f85c290d8f3838eff5e4c77a5420a7d2b951fef77
 DIST wine-8.5.tar.xz 29064032 BLAKE2B 
35fa6d7ec88ff67d9acf13466b3618eb45d664bed0a9ee581e46cb6e7692395837c8c8e86dead1dbcad582ef29c674a0df4b7180addee837b466eba7fdcd350a
 SHA512 
f6aaab8a32eb7bce7f48d21d99417c9e6e8fe41b3d36320762775ef954db7ddd4fcff01d56475f35038d814557834a41a9e3ae85e5cae8a1b820c5044b42a327
 DIST wine-8.6.tar.xz 29118124 BLAKE2B 
e4659785722f0c1adb9ce4a156fbafc8484977a5fe2f4a6e1d5eaf8f1f14c6787f080b9d389cdd8716eb7fd00ee2879fab2042af5dcb970530d2e19628442c73
 SHA512 
602680675f5e062121767769106199179c52a6dd93e97b9b8b4d8365134c72f7745e37d4e3edf6c89c553fb1bfe55b914e77177508fb4f032410d423359abba7
+DIST wine-8.7.tar.xz 29158096 BLAKE2B 
73bd0b5a6eec8a2e37301d8b0f8e9be1ad757f07df3471b0cea17aac6716d456eea1d36fa22bd2451e6cc7662b2b36e4ca628d65216c60d5950f5b439fd2052c
 SHA512 
0a7fe9ad86cf931527c2149207473bf4671d1098af7c21f1b740dfaa84486a8e235fea99b1cad035ff9c3eb20810caab53d51051d63efe626514b79309904d93

diff --git a/app-emulation/wine-vanilla/wine-vanilla-8.7.ebuild 
b/app-emulation/wine-vanilla/wine-vanilla-8.7.ebuild
new file mode 100644
index 000000000000..1a71740166ff
--- /dev/null
+++ b/app-emulation/wine-vanilla/wine-vanilla-8.7.ebuild
@@ -0,0 +1,335 @@
+# Copyright 2022-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+MULTILIB_COMPAT=( abi_x86_{32,64} )
+inherit autotools flag-o-matic multilib multilib-build toolchain-funcs wrapper
+
+WINE_GECKO=2.47.4
+WINE_MONO=7.4.0
+
+if [[ ${PV} == *9999 ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="https://gitlab.winehq.org/wine/wine.git";
+else
+       (( $(ver_cut 2) )) && WINE_SDIR=$(ver_cut 1).x || WINE_SDIR=$(ver_cut 
1).0
+       
SRC_URI="https://dl.winehq.org/wine/source/${WINE_SDIR}/wine-${PV}.tar.xz";
+       S="${WORKDIR}/wine-${PV}"
+       KEYWORDS="-* ~amd64 ~x86"
+fi
+
+DESCRIPTION="Free implementation of Windows(tm) on Unix, without external 
patchsets"
+HOMEPAGE="
+       https://www.winehq.org/
+       https://gitlab.winehq.org/wine/wine/";
+
+LICENSE="LGPL-2.1+ BSD-2 IJG MIT OPENLDAP ZLIB gsm libpng2 libtiff"
+SLOT="${PV}"
+IUSE="
+       +X +abi_x86_32 +abi_x86_64 +alsa capi crossdev-mingw cups dos
+       llvm-libunwind debug custom-cflags +fontconfig +gecko gphoto2
+       +gstreamer kerberos +mingw +mono netapi nls odbc opencl +opengl
+       osmesa pcap perl pulseaudio samba scanner +sdl selinux smartcard
+       +ssl +truetype udev udisks +unwind usb v4l +vulkan wayland
+       +xcomposite xinerama"
+REQUIRED_USE="
+       X? ( truetype )
+       crossdev-mingw? ( mingw )" # bug #551124 for truetype
+
+# tests are non-trivial to run, can hang easily, don't play well with
+# sandbox, and several need real opengl/vulkan or network access
+RESTRICT="test"
+
+# `grep WINE_CHECK_SONAME configure.ac` + if not directly linked
+WINE_DLOPEN_DEPEND="
+       X? (
+               x11-libs/libXcursor[${MULTILIB_USEDEP}]
+               x11-libs/libXfixes[${MULTILIB_USEDEP}]
+               x11-libs/libXi[${MULTILIB_USEDEP}]
+               x11-libs/libXrandr[${MULTILIB_USEDEP}]
+               x11-libs/libXrender[${MULTILIB_USEDEP}]
+               x11-libs/libXxf86vm[${MULTILIB_USEDEP}]
+               opengl? (
+                       media-libs/libglvnd[X,${MULTILIB_USEDEP}]
+                       osmesa? ( media-libs/mesa[osmesa,${MULTILIB_USEDEP}] )
+               )
+               xcomposite? ( x11-libs/libXcomposite[${MULTILIB_USEDEP}] )
+               xinerama? ( x11-libs/libXinerama[${MULTILIB_USEDEP}] )
+       )
+       cups? ( net-print/cups[${MULTILIB_USEDEP}] )
+       fontconfig? ( media-libs/fontconfig[${MULTILIB_USEDEP}] )
+       kerberos? ( virtual/krb5[${MULTILIB_USEDEP}] )
+       netapi? ( net-fs/samba[${MULTILIB_USEDEP}] )
+       odbc? ( dev-db/unixODBC[${MULTILIB_USEDEP}] )
+       sdl? ( media-libs/libsdl2[haptic,joystick,${MULTILIB_USEDEP}] )
+       ssl? ( net-libs/gnutls:=[${MULTILIB_USEDEP}] )
+       truetype? ( media-libs/freetype[${MULTILIB_USEDEP}] )
+       udisks? ( sys-apps/dbus[${MULTILIB_USEDEP}] )
+       v4l? ( media-libs/libv4l[${MULTILIB_USEDEP}] )
+       vulkan? ( media-libs/vulkan-loader[${MULTILIB_USEDEP}] )"
+WINE_COMMON_DEPEND="
+       ${WINE_DLOPEN_DEPEND}
+       X? (
+               x11-libs/libX11[${MULTILIB_USEDEP}]
+               x11-libs/libXext[${MULTILIB_USEDEP}]
+       )
+       alsa? ( media-libs/alsa-lib[${MULTILIB_USEDEP}] )
+       capi? ( net-libs/libcapi:=[${MULTILIB_USEDEP}] )
+       gphoto2? ( media-libs/libgphoto2:=[${MULTILIB_USEDEP}] )
+       gstreamer? (
+               dev-libs/glib:2[${MULTILIB_USEDEP}]
+               media-libs/gst-plugins-base:1.0[${MULTILIB_USEDEP}]
+               media-libs/gstreamer:1.0[${MULTILIB_USEDEP}]
+       )
+       opencl? ( virtual/opencl[${MULTILIB_USEDEP}] )
+       pcap? ( net-libs/libpcap[${MULTILIB_USEDEP}] )
+       pulseaudio? ( media-libs/libpulse[${MULTILIB_USEDEP}] )
+       scanner? ( media-gfx/sane-backends[${MULTILIB_USEDEP}] )
+       smartcard? ( sys-apps/pcsc-lite[${MULTILIB_USEDEP}] )
+       udev? ( virtual/libudev:=[${MULTILIB_USEDEP}] )
+       unwind? (
+               llvm-libunwind? ( sys-libs/llvm-libunwind[${MULTILIB_USEDEP}] )
+               !llvm-libunwind? ( sys-libs/libunwind:=[${MULTILIB_USEDEP}] )
+       )
+       usb? ( dev-libs/libusb:1[${MULTILIB_USEDEP}] )
+       wayland? ( dev-libs/wayland[${MULTILIB_USEDEP}] )"
+RDEPEND="
+       ${WINE_COMMON_DEPEND}
+       app-emulation/wine-desktop-common
+       dos? ( games-emulation/dosbox )
+       gecko? ( app-emulation/wine-gecko:${WINE_GECKO}[${MULTILIB_USEDEP}] )
+       gstreamer? ( media-plugins/gst-plugins-meta:1.0[${MULTILIB_USEDEP}] )
+       mono? ( app-emulation/wine-mono:${WINE_MONO} )
+       perl? (
+               dev-lang/perl
+               dev-perl/XML-LibXML
+       )
+       samba? ( net-fs/samba[winbind] )
+       selinux? ( sec-policy/selinux-wine )
+       udisks? ( sys-fs/udisks:2 )"
+DEPEND="
+       ${WINE_COMMON_DEPEND}
+       sys-kernel/linux-headers
+       X? ( x11-base/xorg-proto )"
+BDEPEND="
+       dev-lang/perl
+       sys-devel/binutils
+       sys-devel/bison
+       sys-devel/flex
+       virtual/pkgconfig
+       mingw? ( !crossdev-mingw? (
+               >=dev-util/mingw64-toolchain-10.0.0_p1-r2[${MULTILIB_USEDEP}]
+       ) )
+       nls? ( sys-devel/gettext )
+       wayland? ( dev-util/wayland-scanner )"
+IDEPEND=">=app-eselect/eselect-wine-2"
+
+QA_CONFIG_IMPL_DECL_SKIP=(
+       __clear_cache # unused on amd64+x86 (bug #900338)
+       res_getservers # false positive
+)
+QA_TEXTRELS="usr/lib/*/wine/i386-unix/*.so" # uses -fno-PIC -Wl,-z,notext
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-7.0-noexecstack.patch
+       "${FILESDIR}"/${PN}-7.20-unwind.patch
+)
+
+pkg_pretend() {
+       [[ ${MERGE_TYPE} == binary ]] && return
+
+       if use crossdev-mingw && [[ ! -v MINGW_BYPASS ]]; then
+               local mingw=-w64-mingw32
+               for mingw in $(usev abi_x86_64 x86_64${mingw}) $(usev 
abi_x86_32 i686${mingw}); do
+                       if ! type -P ${mingw}-gcc >/dev/null; then
+                               eerror "With USE=crossdev-mingw, you must 
prepare the MinGW toolchain"
+                               eerror "yourself by installing 
sys-devel/crossdev then running:"
+                               eerror
+                               eerror "    crossdev --target ${mingw}"
+                               eerror
+                               eerror "For more information, please see: 
https://wiki.gentoo.org/wiki/Mingw";
+                               die "USE=crossdev-mingw is enabled, but 
${mingw}-gcc was not found"
+                       fi
+               done
+       fi
+}
+
+src_prepare() {
+       # sanity check, bumping these has a history of oversights
+       local geckomono=$(sed -En '/^#define (GECKO|MONO)_VER/{s/[^0-9.]//gp}' \
+               dlls/appwiz.cpl/addons.c || die)
+       if [[ ${WINE_GECKO}$'\n'${WINE_MONO} != "${geckomono}" ]]; then
+               local gmfatal=
+               [[ ${PV} == *9999 ]] && gmfatal=nonfatal
+               ${gmfatal} die -n "gecko/mono mismatch in ebuild, has: " 
${geckomono} " (please file a bug)"
+       fi
+
+       default
+
+       # ensure .desktop calls this variant + slot
+       sed -i "/^Exec=/s/wine /${P} /" loader/wine.desktop || die
+
+       # always update for patches (including user's wrt #432348)
+       eautoreconf
+       tools/make_requests || die # perl
+}
+
+src_configure() {
+       WINE_PREFIX=/usr/lib/${P}
+       WINE_DATADIR=/usr/share/${P}
+
+       local conf=(
+               --prefix="${EPREFIX}"${WINE_PREFIX}
+               --datadir="${EPREFIX}"${WINE_DATADIR}
+               --includedir="${EPREFIX}"/usr/include/${P}
+               --libdir="${EPREFIX}"${WINE_PREFIX}
+               --mandir="${EPREFIX}"${WINE_DATADIR}/man
+               $(use_enable gecko mshtml)
+               $(use_enable mono mscoree)
+               --disable-tests
+               $(use_with X x)
+               $(use_with alsa)
+               $(use_with capi)
+               $(use_with cups)
+               $(use_with fontconfig)
+               $(use_with gphoto2 gphoto)
+               $(use_with gstreamer)
+               $(use_with kerberos gssapi)
+               $(use_with kerberos krb5)
+               $(use_with mingw)
+               $(use_with netapi)
+               $(use_with nls gettext)
+               $(use_with opencl)
+               $(use_with opengl)
+               $(use_with osmesa)
+               --without-oss # media-sound/oss is not packaged (OSSv4)
+               $(use_with pcap)
+               $(use_with pulseaudio pulse)
+               $(use_with scanner sane)
+               $(use_with sdl)
+               $(use_with smartcard pcsclite)
+               $(use_with ssl gnutls)
+               $(use_with truetype freetype)
+               $(use_with udev)
+               $(use_with udisks dbus) # dbus is only used for udisks
+               $(use_with unwind)
+               $(use_with usb)
+               $(use_with v4l v4l2)
+               $(use_with vulkan)
+               $(use_with wayland)
+               $(use_with xcomposite)
+               $(use_with xinerama)
+               $(usev !odbc ac_cv_lib_soname_odbc=)
+       )
+
+       tc-ld-force-bfd # builds with non-bfd but broken at runtime (bug 
#867097)
+       filter-lto # build failure
+       use mingw || filter-flags -fno-plt # build failure
+       use custom-cflags || strip-flags # can break in obscure ways at runtime
+       use crossdev-mingw || 
PATH=${BROOT}/usr/lib/mingw64-toolchain/bin:${PATH}
+
+       # temporary workaround for tc-ld-force-bfd not yet enforcing with mold
+       # https://github.com/gentoo/gentoo/pull/28355
+       [[ $($(tc-getCC) ${LDFLAGS} -Wl,--version 2>/dev/null) == mold* ]] &&
+               append-ldflags -fuse-ld=bfd
+
+       # build using upstream's way (--with-wine64)
+       # order matters: configure+compile 64->32, install 32->64
+       local -i bits
+       for bits in $(usev abi_x86_64 64) $(usev abi_x86_32 32); do
+       (
+               einfo "Configuring ${PN} for ${bits}bits in 
${WORKDIR}/build${bits} ..."
+
+               mkdir ../build${bits} || die
+               cd ../build${bits} || die
+
+               pe_arch=i386
+               if (( bits == 64 )); then
+                       pe_arch=x86_64
+                       : "${CROSSCC:=${CROSSCC_amd64:-x86_64-w64-mingw32-gcc}}"
+                       conf+=( --enable-win64 )
+               elif use amd64; then
+                       conf+=(
+                               $(usev abi_x86_64 --with-wine64=../build64)
+                               TARGETFLAGS=-m32 # for widl
+                       )
+                       # _setup is optional, but use over Wine's auto-detect 
(+#472038)
+                       multilib_toolchain_setup x86
+               fi
+               : "${CROSSCC:=${CROSSCC_x86:-i686-w64-mingw32-gcc}}"
+
+               if use mingw; then
+                       # CROSSCC is no longer recognized by Wine, but still 
use for now
+                       # (future handling for CROSS* variables is subject to 
changes)
+                       conf+=( ac_cv_prog_${pe_arch}_CC="${CROSSCC}" )
+
+                       # use *FLAGS for mingw, but strip unsupported
+                       : "${CROSSCFLAGS:=$(
+                               # >=wine-7.21 configure.ac no longer adds 
-fno-strict by mistake
+                               append-cflags '-fno-strict-aliasing'
+                               filter-flags '-fstack-clash-protection' #758914
+                               filter-flags '-fstack-protector*' #870136
+                               filter-flags '-mfunction-return=thunk*' #878849
+                               CC=${CROSSCC} test-flags-CC ${CFLAGS:--O2})}"
+                       : "${CROSSLDFLAGS:=$(
+                               filter-flags '-fuse-ld=*'
+                               CC=${CROSSCC} test-flags-CCLD ${LDFLAGS})}"
+                       export CROSS{C,LD}FLAGS
+               fi
+
+               ECONF_SOURCE=${S} econf "${conf[@]}"
+       )
+       done
+}
+
+src_compile() {
+       use abi_x86_64 && emake -C ../build64 # do first
+       use abi_x86_32 && emake -C ../build32
+}
+
+src_install() {
+       use abi_x86_32 && emake DESTDIR="${D}" -C ../build32 install
+       use abi_x86_64 && emake DESTDIR="${D}" -C ../build64 install # do last
+
+       # symlink for plain 'wine' and install its man pages if 64bit-only 
#404331
+       if use abi_x86_64 && use !abi_x86_32; then
+               dosym wine64 ${WINE_PREFIX}/bin/wine
+               dosym wine64-preloader ${WINE_PREFIX}/bin/wine-preloader
+               local man
+               for man in ../build64/loader/wine.*man; do
+                       : "${man##*/wine}"
+                       : "${_%.*}"
+                       insinto ${WINE_DATADIR}/man/${_:+${_#.}/}man1
+                       newins ${man} wine.1
+               done
+       fi
+
+       use perl || rm "${ED}"${WINE_DATADIR}/man/man1/wine{dump,maker}.1 \
+               "${ED}"${WINE_PREFIX}/bin/{function_grep.pl,wine{dump,maker}} 
|| die
+
+       # create variant wrappers for eselect-wine
+       local bin
+       for bin in "${ED}"${WINE_PREFIX}/bin/*; do
+               make_wrapper "${bin##*/}-${P#wine-}" "${bin#"${ED}"}"
+       done
+
+       # don't let portage try to strip PE files with the wrong
+       # strip executable and instead handle it here (saves ~120MB)
+       if use mingw; then
+               dostrip -x ${WINE_PREFIX}/wine/{i386,x86_64}-windows
+               use debug ||
+                       find "${ED}"${WINE_PREFIX}/wine/*-windows -regex 
'.*\.\(a\|dll\|exe\)' \
+                               -exec $(usex abi_x86_64 x86_64 
i686)-w64-mingw32-strip --strip-unneeded {} + || die
+       fi
+
+       dodoc ANNOUNCE AUTHORS README* documentation/README*
+}
+
+pkg_postinst() {
+       eselect wine update --if-unset || die
+}
+
+pkg_postrm() {
+       eselect wine update --if-unset || die
+}

Reply via email to